package com.example.sam4s;

import com.example.sam4s.R;
import com.sam4s.printer.*;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.WindowManager.LayoutParams;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.ToggleButton;

public class cl_Text extends Activity {
    static final int SEND_TIMEOUT = 10 * 1000;
    static final int SIZEWIDTH_MAX = 8;
    static final int SIZEHEIGHT_MAX = 8;

    boolean exitActivity = false;
	private Button btnPrint;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.text);	
		
		btnPrint = (Button)findViewById(R.id.button_print);
		btnPrint.setOnClickListener(new btnPrintOnClick());
		
		//init font list
        Spinner spinner = (Spinner)findViewById(R.id.spinner_font);
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        adapter.add(getString(R.string.font_a));
        adapter.add(getString(R.string.font_b));
        spinner.setAdapter(adapter);

        //init align list
        spinner = (Spinner)findViewById(R.id.spinner_align);
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        adapter.add(getString(R.string.align_left));
        adapter.add(getString(R.string.align_center));
        adapter.add(getString(R.string.align_right));
        spinner.setAdapter(adapter);

        //init language list
        spinner = (Spinner)findViewById(R.id.spinner_language);
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        adapter.add(getString(R.string.language_eng));
        adapter.add(getString(R.string.language_kor));
        spinner.setAdapter(adapter);
        
        //init size list
        spinner = (Spinner)findViewById(R.id.spinner_size_width);
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        for(int i = 1; i <= SIZEWIDTH_MAX; i++){
            adapter.add(String.format("%d", i));
        }
        spinner.setAdapter(adapter);
        
        spinner = (Spinner)findViewById(R.id.spinner_size_height);
        adapter = new ArrayAdapter<String>(this, android.R.layout.simple_spinner_item);
        adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        for(int i = 1; i <= SIZEHEIGHT_MAX; i++){
            adapter.add(String.format("%d", i));
        }
        spinner.setAdapter(adapter);
        
        //default setting
        TextView text = (TextView)findViewById(R.id.editText_text);
        String value = getString(R.string.text_edit_text);
        value = value.replaceAll("\\*", " ");
        text.setText(value);
        
        text = (TextView)findViewById(R.id.editText_linespace);
        text.setText("30");
        
        text = (TextView)findViewById(R.id.editText_xposition);
        text.setText("0");
        
        text = (TextView)findViewById(R.id.editText_feedunit);
        text.setText("30");

        //hide keyboard
        this.getWindow().setSoftInputMode(LayoutParams.SOFT_INPUT_STATE_ALWAYS_HIDDEN);
	}
	
	class btnPrintOnClick implements View.OnClickListener
	{
		public void onClick(View v)
		{
			try
			{
				TextView text = (TextView)findViewById(R.id.editText_text);
		        if(text.getText().toString().isEmpty()){
		        	cl_Main.showMsg("No Text", getBaseContext());
		            return ;
		        }
		        
		        Sam4sBuilder builder = null;
		        
		        try{
		            //create builder
		            //Builder
		            builder = new Sam4sBuilder("ELLIX", Sam4sBuilder.LANG_KO);

		            //add command
		            //addTextFont
		            builder.addTextFont(getBuilderFont());
		            
		            //addTextAlign
		            builder.addTextAlign(getBuilderAlign());
		            
		            //addTextPosition
		            builder.addTextPosition(getBuilderXPosition());		            
		            
		            //addTextLineSpace
		            builder.addTextLineSpace(getBuilderLineSpace());
		            
		            //addTextLang
		            builder.addTextLang(getBuilderLanguage());
		            
		            //addTextSize
		            builder.addTextSize(getBuilderSizeW(), getBuilderSizeH());
		            
		            //addTextStyle
		            builder.addTextStyle(false, getBuilderStyleUnderline(), getBuilderStyleBold(), Sam4sBuilder.COLOR_1);
		            
		            //addText
		            builder.addText(getBuilderText());
		            
		            //addFeedUnit
		            builder.addFeedUnit(getBuilderFeedUnit());

		            //send builder data
		            try{	              		                
		            	cl_Menu.mPrinter.sendData(builder);
		            }catch(Exception e){
		            	cl_Main.showMsg(e.getMessage(), getBaseContext());    
		            }
		        }catch(Exception e){
		        	cl_Main.showMsg(e.getMessage(), getBaseContext());
		        }
		        
		        //remove builder
		        if(builder != null){
		            try{
		                builder.clearCommandBuffer();
		                builder = null;
		            }catch(Exception e){
		                builder = null;
		            }
		        }
			}
			catch(Exception ex)
			{
				ex.printStackTrace();
			}
		}
	}
	
	private int getBuilderFont() {
        Spinner spinner = (Spinner)findViewById(R.id.spinner_font);
        switch(spinner.getSelectedItemPosition()){
        case 1:
            return Sam4sBuilder.FONT_B;
        case 0:
        default:
            return Sam4sBuilder.FONT_A;
        }
    }
    
    private int getBuilderAlign() {
        Spinner spinner = (Spinner)findViewById(R.id.spinner_align);
        switch(spinner.getSelectedItemPosition()){
        case 1:
            return Sam4sBuilder.ALIGN_CENTER;
        case 2:
            return Sam4sBuilder.ALIGN_RIGHT;
        case 0:
        default:
            return Sam4sBuilder.ALIGN_LEFT;
        }
    }
    
    private int getBuilderLineSpace() {
        TextView text = (TextView)findViewById(R.id.editText_linespace);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }

    private int getBuilderXPosition() {
        TextView text = (TextView)findViewById(R.id.editText_xposition);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }
    
    private int getBuilderLanguage() {
        Spinner spinner = (Spinner)findViewById(R.id.spinner_language);
        switch(spinner.getSelectedItemPosition()){
        case 1:
            return Sam4sBuilder.LANG_KO;
        case 0:
        default:
            return Sam4sBuilder.LANG_EN;
        }
    }
    
    private int getBuilderSizeW() {
        Spinner spinner = (Spinner)findViewById(R.id.spinner_size_width);
        return spinner.getSelectedItemPosition() + 1;
    }
        
    private int getBuilderSizeH() {
        Spinner spinner = (Spinner)findViewById(R.id.spinner_size_height);
        return spinner.getSelectedItemPosition() + 1;
    }

    private boolean getBuilderStyleBold() {
        ToggleButton toggle = (ToggleButton)findViewById(R.id.toggleButton_style_bold);
        if(toggle.isChecked()){
            return true;
        }else{
            return false;
        }
    }

    private boolean getBuilderStyleUnderline() {
        ToggleButton toggle = (ToggleButton)findViewById(R.id.toggleButton_style_underline);
        if(toggle.isChecked()){
            return true;
        }else{
            return false;
        }
    }
    
    private String getBuilderText() {
        TextView text = (TextView)findViewById(R.id.editText_text);
			
		return text.getText().toString();					
    }

    private int getBuilderFeedUnit() {
        TextView text = (TextView)findViewById(R.id.editText_feedunit);
        try{
            return Integer.parseInt(text.getText().toString());
        }catch(Exception e){
            return 0;
        }
    }

}
